/*
 * 谷歌原生网页翻译
 */
(function (Doc) {
  /* 判断是否该执行 */
  /* 网址黑名单制，遇到这些域名不执行 */
  const blackList = ['zhihu.com', 'twitter.com', 'wenku.baidu.com', 'wk.baidu.com'];

  const hostname = window.location.hostname;
  const key = encodeURIComponent('谷歌原生网页翻译:执行判断');
  const isBlack = blackList.some(keyword => {
    if (hostname.match(keyword)) {
      return true;
    };
    return false;
  });

  if (isBlack || window[key]) {
    return;
  };
  window[key] = true;

  /* 开始执行代码 */
  const config = {
    initName: 'googleTranslate',
    initElm: 'google_translate_elm',
    /*多语言页面支持*/
    multilanguagePage: true,
    /* 哪种需要转 */
    pageLanguage: 'auto',
    /* 能转成啥 */
    includedLanguages: 'zh-CN,zh-TW,en',
    /* 隐藏工具bar */
    autoDisplay: false
  };

  /* 注入谷歌翻译脚本 */
  const script = document.createElement('script');
  script.src = `//translate.google.cn/translate_a/element.js?&cb=${config.initName}`;
  script.async = true;
  document.head.appendChild(script);

  /* 创建谷歌翻译右下角的语言选择框容器 */
  const div = document.createElement('div');
  div.id = config.initElm;
  div.setAttribute('style', `
    position: fixed;
    bottom: 5vw;
    right: 5vw;
    z-index: 999999999;
  `);
  document.documentElement.appendChild(div);

  /* 一些样式 */
  const style = document.createElement('style');
  style.innerHTML = `
    body {
      position: relative;
      top: 0 !important;
      left: 0 !important;
    }
    .skiptranslate iframe{
      width: 0px !important;
      height: 0px !important;
      overflow: hidden;
      display: none !important;
    }
    .goog-te-gadget-simple {
      width: 0px !important;
      height: 0px !important;
      border: 1px solid #ececec !important;
      border-radius: 4px;
      padding: 8px;
      line-height: 26px;
      text-align: center;
      visibility: hidden;
    }
    .goog-te-gadget-simple a,.goog-te-gadget-simple a:link,.goog-te-gadget-simple a:visited,.goog-te-gadget-simple a:hover,.goog-te-gadget-simple a:active{
      text-decoration: none;
      color:inherit;
    }
  `;
  document.head.appendChild(style);

  /* 谷歌翻译实例化函数 */
  window[config.initName] = () => {
    new window.google.translate.TranslateElement({
      layout: google.translate.TranslateElement.InlineLayout.SIMPLE,
      multilanguagePage: config.multilanguagePage,
      pageLanguage: config.pageLanguage,
      includedLanguages: config.includedLanguages,
      autoDisplay: config.autoDisplay
    }, config.initElm);
  };

  /* 监听dom函数 */
  function observe({ targetNode, config = {}, callback = () => { } }) {
    if (!targetNode) {
      return;
    };
    config = Object.assign({
      attributes: true,
      childList: true,
      subtree: true
    }, config);
    const observer = new MutationObserver(callback);
    observer.observe(targetNode, config);
  };

  if (!Doc.$ZJZYTRANSLATION) {
      var k = {
          translationWithLanguage: function(language) {
              var interval = setInterval(function iframeTagFinder() {
                  if(language.indexOf("原文") != -1){
                      Doc.document.getElementById(":2.container").contentWindow.document.getElementById(":2.restore").click()
                      //onTranslationListen(iframeDoc);
                      clearInterval(interval);
                      return;
                  }
                  var iframes = document.getElementsByClassName("goog-te-menu-frame skiptranslate")
                  if(iframes.length != 0){
                      var iframeDoc = document.getElementsByClassName("goog-te-menu-frame skiptranslate")[0].contentWindow.document;
                      var aTags = iframeDoc.getElementsByTagName("a")
                      for(var index = 0; index < aTags.length; index++){
                          var aTag = aTags[index];
                          var aText = aTag.text;
                          if(aText.indexOf(language) != -1){
                              aTag.click();
                              break;
                          }
                      }
                      //onTranslationListen(iframeDoc);
                      clearInterval(interval);
                  }
              }, 333);
          },
          queryTranslationProgress: function(){
                var result = "";
                if(Doc.document.getElementById(":2.container") == null){
                    return ""
                }
                var iframeDoc = Doc.document.getElementById(":2.container").contentWindow.document
                var finishSection = iframeDoc.getElementById(":2.finishSection").style.display
                var errorSection = iframeDoc.getElementById(":2.errorSection").style.display
                if(finishSection == "" && errorSection == "none"){
                     result = true;
                }
                if(finishSection == "none" && errorSection == ""){
                     result = false;
                }
                return result;
          }
      };
      Doc.$ZJZYTRANSLATION = k;
  }

  function onTranslationListen(initElm){
      if (window.isInitObserve){
         return;
      }
      window.isInitObserve = true;

      /* 监听右下角的语言选择框 */
      //const initElm = document.querySelector(`#${config.initElm}`);
      observe({
        targetNode: initElm,
        config: {
          attributes: false
        },
        callback(mutationList, observer) {
//            var iframeDoc = Doc.document.getElementById(":2.container").contentWindow.document
//            var finishSection = iframeDoc.getElementById(":2.finishSection").style.display
//            var errorSection = iframeDoc.getElementById(":2.errorSection").style.display
//            if(finishSection == "" && errorSection == "none"){
//                 Doc.kingTranslation.complete();
//            }
//            if(finishSection == "none" && errorSection == ""){
//                 Doc.kingTranslation.fail();
//            }
        }
      });
  }

})(window);